type expr =
  | Var of string
  | Lam of string * expr
  | App of expr * expr

val unparse : expr -> string

val free_vars : expr -> string list
val is_alpha : expr -> expr -> bool
val subst : string -> expr -> expr -> expr
val beta : expr -> expr option
val normal_form : expr -> expr
val expr_of_int : int -> expr
val add : expr -> expr -> expr
val int_of_expr: expr -> int
